//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.util.*;
import java.io.*; 

public class ProtoVec {
  Vector m,z,v,v2,vcnt;
  boolean error;
  public ProtoVec() {
    error = false;
    m = new Vector ((int)30,(int)3);//matriz de ejemplares
    z = new Vector ((int)30,(int)3);//matriz de vectores prototipo
    vcnt = new Vector ((int)30,(int)3);//contadores
    char ch = '';
    String str = "";
    Integer cnt;
    Float num,n1,n2,n3;
    int ind = 1;
    FileInputStream istream = null ;
    try { //read from file
      istream = new FileInputStream("in.txt");
      while (ch != '|') {
        ch = '';
        v = new Vector ((int)30,(int)3);
        while ((ch != '\n')&&(ch != '|')) {
          str = "";
          ch = (char)istream.read();
          while ((ch != ' ')&&(ch != '\n')&&(ch != '|')) { //read number
            str+= ch;
            ch = (char)istream.read();
          }
          if (ch != '|') {
            //System.out.println(str); 
            num = new Float(str);
            v.addElement(num);//add number
            ind++;
          }
        }
        m.addElement(v);
        boolean newclass = true;
        for (int i = 0;i < z.size();i++) {
          v2 = (Vector)z.elementAt(i);
          n1 = (Float)v.lastElement();
          n2 = (Float)v2.lastElement();
          if(n1.floatValue() == n2.floatValue()) {
            newclass = false;
            for (int j = 0;j < (v.size()-1);j++) {
              n1 = (Float)v.elementAt(j);
              n2 = (Float)v2.elementAt(j);
              n3 = new Float(n1.floatValue()+n2.floatValue());
              v2.setElementAt(n3,j);
            }
            cnt = (Integer)vcnt.elementAt(i);
            cnt = new Integer(1+cnt.intValue());
            vcnt.setElementAt(cnt,i);
          }
        }
        if (newclass) {
          cnt = new Integer(1);
          vcnt.addElement(cnt);
          z.addElement(v);
        }
      }
      istream.close();
    } catch(IOException ioe) {
      System.out.println(ioe.getMessage());
    }
    
    FileOutputStream ostream = null ;
    try { //write to file
      ostream = new FileOutputStream("out.txt");
      for (int i = 0;i < z.size();i++) {
        v = (Vector)z.elementAt(i);
        cnt = (Integer)vcnt.elementAt(i);
        //System.out.println(cnt); 
        for (int j = 0;j < (v.size()-1);j++) {
          n1 = (Float)v.elementAt(j);
          n3 = new Float(n1.floatValue()/cnt.intValue());
          v.setElementAt(n3,j);
          str = n3.toString();
          ostream.write(str.getBytes());
          ostream.write(' '); 
        }
        n1 = (Float)v.lastElement();
        str = n1.toString();
        ostream.write(str.getBytes());
        ostream.write('\n'); 
      }
      ostream.close();
    } catch(IOException ioe) {
      System.out.println(ioe.getMessage());
    }
    
  }
  
  public static void main(String[] args) {
    ProtoVec p = new ProtoVec();
  }
}