//ordena
//Carlos Gershenson

import java.util.Vector;
import java.io.*; 

public class CI{
  Vector vecToStr(String s){
    Vector vec=new Vector(s.length());
    char[]str=s.toCharArray();
    Character ch;
    for (int i=0;i<s.length();i++){
      ch= new Character(str[i]);
      vec.addElement(ch);
    }
    return vec;
  }
  void showVec(Vector vec){
    Character ch;
    for (int i=0; i<vec.size();i++){
      ch=(Character)vec.elementAt(i);
      System.out.print(ch.charValue()+" ");
    }
    System.out.println();
  }
  int fact(int n){
    int r=1;
    for (int i=1;i<n;i++){
      r*=i;
    }
    return r;
  }
  int comb (int n, int k){
    return (fact(n)/(fact(k)*fact(n-k)));
  }
  
  Vector comb(Vector vo, int k){
    Vector v=(Vector)vo.clone();
    int n=v.size();
    //showVec(v);
    Vector m= new Vector(comb(n,k));
    Vector m2,v2;
    Character ch;
    if (k<=1){
      for(int i=0;i<(n-k+1);i++){
        v2=new Vector(1);
        ch=(Character) v.elementAt(i);
        v2.addElement(ch);
        m.addElement(v2);
      }
    }else{
      for(int i=0;i<(n-k+1);i++){
        ch=(Character) v.elementAt(0);
        v.removeElementAt(0);
        m2=new Vector(comb(v.size(),k-1));
        m2=comb(v,k-1);
        for (int j=0;j<m2.size();j++){
          v2=(Vector)m2.elementAt(j);
          v2.insertElementAt(ch,0);
          m.addElement(v2);
        }
      }
    }
    return m;
  }
  
  public CI(String arg){
    Vector v,v2,v3;
    v=vecToStr(arg);
    v3=new Vector((int)Math.pow(2,v.size())-1);
    for (int i=1;i<=v.size();i++){
      v2=comb(v,i);
      v3.addAll(v2);
      /*System.out.println(v2);*/
    }
    write("CI.txt",v3);
  }
  public void write(String file, Vector z){
    Vector v;
    Character ch;
    String str;
    int cnt=0;
    FileOutputStream ostream = null ;
    try { //write to file
      ostream = new FileOutputStream(file);
      for (int i = 0;i < z.size();i++) {
        v = (Vector)z.elementAt(i);
        cnt++;
        str=new Integer(cnt).toString();
        ostream.write(str.getBytes());
          ostream.write('-'); 
        for (int j = 0;j < (v.size());j++) {
          ch = (Character)v.elementAt(j);
          ostream.write(ch.charValue());
          /*ostream.write(' ');*/
        }
        ostream.write('\n'); 
      }
      ostream.close();
    } catch(IOException ioe) {
      System.out.println(ioe.getMessage());
    }
  }

  public static void main(String[] args) {
    CI ci=new CI(args[0]);
  }

}